/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id$
 *
 ******************************************************************************/
package it.tidalwave.metadata.persistence.node;

import javax.annotation.Nonnull;
import org.openide.nodes.Node;
import org.openide.util.Lookup;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public interface MetadataPersistenceNodeManager 
  {
    public static final class Locator
      {
        private Locator()
          {
          }
        
        /***********************************************************************
         * 
         * Gets a reference to the MetadataPersistenceNodeManager.
         * 
         **********************************************************************/
        @Nonnull
        public static final MetadataPersistenceNodeManager findMetadataPersistenceNodeManager()
          {
            final Lookup lookup = Lookup.getDefault();
            final MetadataPersistenceNodeManager metadataPersistenceNodeManager = lookup.lookup(MetadataPersistenceNodeManager.class);

            if (metadataPersistenceNodeManager == null)
              {
                throw new RuntimeException("Cannot lookup MetadataPersistenceNodeManager");
              }

            return metadataPersistenceNodeManager;
          }
      } 
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    public Node getRootNode();
  }
