/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id$
 *
 ******************************************************************************/
package it.tidalwave.metadata.persistence.node.impl;

import it.tidalwave.metadata.persistence.node.MetadataPersistenceNodeManager;
import it.tidalwave.netbeans.nodes.EnhancedNode;
import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;
import java.awt.Image;
import org.openide.nodes.Node.Property;
import org.openide.nodes.Node.PropertySet;
import org.openide.nodes.Children;
import org.openide.util.lookup.Lookups;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
// FIXME: complete transition to EnhancedNode, using capabilities and getting rid of nodeManager
public class ManagedNode extends EnhancedNode
  {
    protected static final MetadataPersistenceNodeManagerImpl nodeManager =
            (MetadataPersistenceNodeManagerImpl)MetadataPersistenceNodeManager.Locator.findMetadataPersistenceNodeManager();
    
    private final PropertySet[] propertySets = new PropertySet[1];
    
    private final List<Property<?>> properties = new ArrayList<Property<?>>();
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    public ManagedNode (@Nonnull final Children children, @Nonnull final Object ... object)
      {
        super("foobar", children, Lookups.fixed(object)); // FIXME
        
        propertySets[0] = new PropertySet() 
          {
            @Override
            public Property<?>[] getProperties() 
              {
                return properties.toArray(new Property<?>[0]);
              }
          };
      }
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    public ManagedNode (@Nonnull final Object ... object)
      {
        this(Children.LEAF, object);    
      }
    
    /***************************************************************************
     *
     * {@inheritDoc}
     *
     **************************************************************************/
    @Override
    @Nonnull
    public final Image getIcon (final int type) 
      {
        return nodeManager.findIcon(this);
      }

    /***************************************************************************
     *
     * {@inheritDoc}
     *
     **************************************************************************/
    @Override
    @Nonnull
    public final Image getOpenedIcon (final int type) 
      {
        return nodeManager.findIcon(this);
      }   

    /***************************************************************************
     *
     * {@inheritDoc}
     *
     **************************************************************************/
    @Override
    public final PropertySet[] getPropertySets() 
      {
        return propertySets.clone();
      }
    
    @Override
    public boolean canCopy()
      {
        return true;
      }
    
    @Override
    public boolean canCut()
      {
        return false;
      }
    
    @Override
    public boolean canDestroy()
      {
        return false;
      }
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    protected void addProperty (@Nonnull final Property<?> property)
      {
        properties.add(property);
      }
  }
